// MyClient.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#define _WIN32_DCOM

#include <windows.h>
#include <stdio.h>
#include <tchar.h>

#import "..\MyRemote\MyRemote.tlb"

#include "../dcom_common.h"

using namespace MYREMOTELib;

// int _tmain(int argc, _TCHAR** argv)
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	HRESULT hr = S_OK;

	hr = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
	
	if (FAILED(hr))
		MessageBox(NULL, "Error on CoInitializeEx", NULL, NULL);
        
	hr = CoInitializeSecurity(
					NULL,
			        -1,    // COM+  񽺸 
					NULL,  // ι°ڰ -1̸ NULL̾ Ѵ.
					NULL,
					RPC_C_AUTHN_LEVEL_NONE,       // 
					RPC_C_IMP_LEVEL_IMPERSONATE,  //   
					NULL,
					EOAC_NONE,
					NULL);

	if (FAILED(hr))
		MessageBox(NULL, "Error on CoInitializeSecurity", NULL, NULL);

	{
	
		IDiskInfoPtr pDiskInfo;
/*		
		COAUTHINFO athn;
		ZeroMemory(&athn, sizeof(COAUTHINFO));

		// Set up the NULL security information
		athn.dwAuthnLevel		  = RPC_C_AUTHN_LEVEL_DEFAULT;
		athn.dwAuthnSvc           = RPC_C_AUTHN_WINNT;
		athn.dwAuthzSvc			  = RPC_C_AUTHZ_NONE;  // NT None
		athn.dwCapabilities		  = EOAC_NONE;
		athn.dwImpersonationLevel = RPC_C_IMP_LEVEL_IMPERSONATE;
		athn.pAuthIdentityData	  = NULL;  //  Ǿ־ ׻ NULL
		athn.pwszServerPrincName  = NULL;  //  Ǿ־ ׻ NULL
*/		
		COSERVERINFO serverinfo;
		ZeroMemory(&serverinfo, sizeof(COSERVERINFO));		
		serverinfo.pwszName    = SVR_ADDR_W;
/*		serverinfo.pAuthInfo   = &athn;
		serverinfo.dwReserved1 = 0;
		serverinfo.dwReserved2 = 0;		
*/
		// __uuidof: Ʈ  GUID 
		MULTI_QI qi;
		qi.pIID = &__uuidof(IDiskInfo);  // IID_IDiskInfo
		qi.pItf = NULL;
		qi.hr   = S_OK;
 		
		try
		{	
			hr = CoCreateInstanceEx(__uuidof(DiskInfo),  // IID_IDiskInfo 128bit
									NULL,
		 							CLSCTX_REMOTE_SERVER,
									&serverinfo,
									1,
									&qi);		
			if (FAILED(hr))
				_com_issue_error(hr);		
		}
		catch(const _com_error& e)
		{
			MessageBox(NULL, e.ErrorMessage(), NULL, NULL);
			return 0;
			// _tprintf(_T("There is an error (%08x): %s\n"), e.Error(), e.ErrorMessage());
		}

		IDiskInfo* pInt = static_cast<IDiskInfo*>(qi.pItf);
		pDiskInfo.Attach(pInt);
		
		// LPC:  ý 󿡼 Ǵ  ٸ μ  Ŀ´̼ 
		// RPC:  Ʈũ  Ŀ Ͽ  ٸ ýۻ󿡼 Ǵ
		// μ  Ŀ´̼ ϴ  Ѵ.
		// Ole32.dll: δٸ μ  ̿ ̽ Ͱ Ѱ öǴ Ʈ
		// COMü Ǵ μ   Ѵ.  Ұ Ǵ
		// IPC(Inter-Process Communication)ä ϰ,  Ŭ̾Ʈ
		// μ  Ͻø   IPCäο Ŵ
		// IPCä: δٸ μ  ִ Ŭ̾Ʈ COMü ̿ ޽ 
		// 		   
		// Ͻÿ : ͸ Ʈũ ߸ (Network Data Representation, NDR)
		//  ϴ ۾ ϴ  COMü NDRŶ IPCä 
		// ؼ Ͻÿ ӻ̿ ۵ȴ.
		// (marshalling): ȣ ͸ Ҽ ǥ ȭϴ 
		// 𸶼(unmarshalling): ǥ ͸ ޴  μ   
		// ȭϴ 

		BSTR svrname;
		try {
			pDiskInfo->GetName(&svrname);
		} catch ( ... ) {
			::MessageBox( NULL, "̽ ޼ҵ ȣ⿡ Ͽϴ.", NULL, MB_OK );
			return 0;
		}
		MessageBox(NULL, _bstr_t(svrname), NULL, NULL);
	}

	CoUninitialize();

	return 0;
}