// DiskInfo.h : Declaration of the CDiskInfo

#ifndef __DISKINFO_H_
#define __DISKINFO_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CDiskInfo
class ATL_NO_VTABLE CDiskInfo : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDiskInfo, &CLSID_DiskInfo>,
	public IDispatchImpl<IDiskInfo, &IID_IDiskInfo, &LIBID_MYREMOTELib>
{
public:
	CDiskInfo()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_DISKINFO)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CDiskInfo)
	COM_INTERFACE_ENTRY(IDiskInfo)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IDiskInfo
public:
	STDMETHOD(GetName)(/*[out]*/ BSTR *svrName);
};

#endif //__DISKINFO_H_
